Home > Articles > Programming > C/C++

  • Print
  • + Share This
This chapter is from the book

This chapter is from the book

11.4 Exception Specifications

It is not possible, looking at the declarations for the member functions pop() and push() of the class iStack, to determine that these functions may throw exceptions. One possible solution is to add a comment associated with the declaration of each member function. In this way, the class interface that appears in the header file also documents the exceptions the class member functions may throw:

class iStack {
public:
   // ...

   void pop( int &value ); 
       // throw popOnEmpty
   void push( int value ); 
       // throw pushOnFull

private:
   // ...
};

However, this is less than ideal. There is no guarantee that this documentation will remain up-to-date with later releases of our iStack class. Nor does it provide information to the compiler to guarantee that no other kinds of exceptions are thrown. An exception specification provides a solution that can be used to list the exceptions a function may throw with the function declaration. It guarantees that the function does not throw any other types of exceptions.

An exception specification follows the function parameter list. It is specified with the keyword throw followed by a list of exception types enclosed in parentheses. For example, the declarations of the member functions of the class iStack can be modified as follows to add the appropriate exception specifications:

class iStack {
public:
   // ...

   void pop( int &value ) throw(popOnEmpty);
   void push( int value ) throw(pushOnFull);

private:
   // ...
};

A call of pop() guarantees not to throw any exception other than an exception of type popOnEmpty. Similarly, a call of push() guarantees not to throw any exception other than an exception of type pushOnFull.

An exception declaration is part of the function's interface, and it must be specified on the function declarations that appear in header files. An exception specification is a contract between the function and the rest of the program. It is a guarantee that the function will not throw any exception not listed in its exception specification.

If a function declaration specifies an exception specification, a redeclaration of the same function must specify an exception specification with the same types. The exception specifications on different declarations of the same function are not cumulative. For example:

// two declarations of the same function
extern int foo( int = 0 ) throw(string);

// error: exception specification omitted
extern int foo( int parm ) { }

What happens if the function throws an exception that is not listed in its exception specification? Exceptions are thrown only if certain program anomalies are encountered, and it is not possible to know at compile- time whether a program encounters these exceptions at run-time. Therefore, violations of a function's exception specification can be detected only at run- time. If a function throws an exception not listed in its exception specification, the function unexpected(), defined in the C++ standard library, is invoked. The default behavior of unexpected() is to call terminate(). (In some situations, it may be necessary to override the actions performed by unexpected(). The C++ standard library provides a mechanism to override the default behavior of unexpected(). [STROUSTRUP97] discusses this in more detail.)

We should clarify that the function unexpected() is not called merely because a function throws an exception not listed in its exception specification. If the function handles the exception itself and if the exception is handled before it "escapes" outside the function, then all is fine. For example:

void recoup( int op1, int op2 ) throw(ExceptionType)
{
   try {
      // ...
      throw string("we're in control");
   }
      // handles the exception thrown
      catch ( string ) {
        // do whatever is needed
   }
} // OK, unexpected() is not called

Even though an exception of type string is thrown from within the function recoup() and even though the function recoup() guarantees not to throw exceptions of a type other than ExceptionType, because the exception is handled before it escapes from the function recoup(), the function unexpected() is not called as a result of this exception being thrown.

Violations of a function's exception specification are detected only at run-time. The compiler does not generate compile-time errors if an expression can throw an exception of a type disallowed by the exception specification. If this expression is never executed or if it never throws the exception that is violating the exception specification, the program runs as expected and the function exception specification is never violated. For example:

extern void doit( int, int ) throw(string, exceptionType);

void action (int op1, int op2 ) throw(string) {
   doit( op1, op2 ); // no compile-time error
   // ...
}

The function doit() can throw an exception of type exceptionType, which is not allowed by the exception specification of the function action() . Even though this type of exception is not allowed by the function action(), this function compiles successfully. Instead, the compiler generates code to ensure that if an exception violating the exception specification is thrown, the run-time library function unexpected() is called.

An empty exception specification guarantees that the function does not throw any exception. For example, the function no_problem() guarantees not to throw an exception:

extern void no_problem() throw();

If a function declaration does not specify an exception specification, the function can throw exceptions of any type.

No type conversion is allowed between the type of the exception thrown and a type specified by the exception specification. For example:

int convert( int parm ) throw(string)
{
   // ...
   if ( somethingRather )
      // program error:
      // convert() does not allow exception of type const char*
      throw "help!";
}

The throw expression in the function convert() throws a C-style character string. The exception object created by this throw expression has type const char*. Usually, an expression of type const char* can be converted to the type string. However, an exception specification does not allow type conversions from the type of the exception thrown to the type specified by the exception specification. If convert() throws this exception, the function unexpected() is called. To correct this situation, the throw expression can be modified to explicitly convert the value of the expression to the type string as follows:

throw string( "help!" );

11.4.1 Exception Specifications and Pointers to Functions

An exception specification can also be provided in the declaration of a pointer to function. For example:

void (*pf)( int ) throw(string);

This declaration indicates that pf points to a function that can throw exceptions only of type string. As with function declarations, the exception specifications of different declarations for the same pointer to function are not cumulative, and all the declarations for the pointer pf must specify the same exception specification. For example:

extern void (*pf)( int ) throw(string);

// error: missing exception specification
void (*pf)( int );

When a pointer to function with an exception specification is initialized (or assigned to), there are restrictions on the type of the pointer used as the initializer (or used as the rvalue on the right-hand side of the assignment). The exception specifications of both pointers do not have to be identical. However, the exception specification of the pointer used as the initializer or rvalue must be either as restrictive as or more restrictive than the exception specification of the pointer that is initialized or assigned to. For example:

void recoup( int, int ) throw(exceptionType);
void no_problem() throw();
void doit( int, int ) throw(string, exceptionType);

// ok: recoup() is as restrictive as pf1
void (*pf1)( int, int ) throw(exceptionType) = &recoup;

// ok: no_problem() is more restrictive than pf2
void (*pf2)() throw(string) = &no_problem;

// error: doit() is less restrictive than pf3
void (*pf3)( int, int ) throw(string) = &doit;

The third initialization does not make sense. The pointer declaration guarantees that pf3 points to a function that will not throw any exceptions except those of type string. However, the function doit() may also throw an exception of type exceptionType. Because the function doit() does not satisfy the guarantee of the exception specification of pf3, the function doit() is not a valid initializer for pf3 and a compiler error is issued.

Exercise 11.9

Using the code you developed for Exercise 11.8, change the declaration of class IntArray operator[]() to add an appropriate exception specification to describe the exception this operator can throw. Modify your program so that operator[]() throws an exception not listed in its exception specification. What happens then?

Exercise 11.10

What exceptions can a function throw if it has an exception specification of the form throw()? If it has no exception specification?

Exercise 11.11

Which one, if any, of the following pointer assignments is in error? Why?

void example() throw(string);
(a) void (*pf1)() = example;

(b) void (*pf2)() throw() = example;
  • + Share This
  • 🔖 Save To Your Account